; 

      .686p                     ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 

; 

      qSortd PROTO :DWORD,:DWORD,:DWORD
      is_correct PROTO :DWORD,:DWORD

      number equ 10000000        ; change the array size here

      memsize equ <number>
      randcnt equ <number>

; 

    ; -----------------------------
    ; macros for displaying results
    ; -----------------------------
      SBtext MACRO part,lpString
        invoke SendMessage,hStatus,SB_SETTEXT,part-1,reparg(lpString)
      ENDM

      TBtext MACRO lpString
        invoke SetWindowText,FUNC(GetActiveWindow),reparg(lpString)
      ENDM

      EDtext MACRO lpString
        invoke SetWindowText,hEdit,reparg(lpString)
      ENDM

      EDclear equ <EDtext 0>

    .data?
        hWnd      dd ?
        hInstance dd ?
        hStatus   dd ?
        hEdit     dd ?

    .code

; 

start: 
    mov hInstance, FUNC(GetModuleHandle,NULL)
    call main
    invoke ExitProcess,eax

; 

main proc

    invoke InitCommonControls

    Dialog "   ", \                         ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            9, \                            ; number of controls
            50,50,250,106, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "qsort3m",WS_TABSTOP,5, 5,50,13,101
    DlgButton "Test 2",WS_TABSTOP,5,20,50,13,102
    DlgButton "Test 3",WS_TABSTOP,5,35,50,13,103
    DlgButton "Test 4",WS_TABSTOP,5,50,50,13,104
    DlgButton "Test 5",WS_TABSTOP,5,65,50,13,105
    DlgButton "Reset",WS_TABSTOP,60,65,50,13,106
    DlgButton "Close",WS_TABSTOP,192,65,50,13,IDCANCEL
    DlgStatus 110
    DlgEdit WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or \
            ES_LEFT or WS_BORDER or WS_VSCROLL,60,5,182,58,111

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

align 4

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL hDC   :DWORD
    LOCAL hMem  :DWORD
    LOCAL ps    :PAINTSTRUCT 
    LOCAL rct   :RECT 
    LOCAL crct  :RECT 
    LOCAL buffer1[260]:BYTE 
    LOCAL buffer2[260]:BYTE 
    LOCAL buffer3[260]:BYTE 
    LOCAL buffer4[260]:BYTE 

    STRING MainTitle,"Algorith Test Bed"

    Switch uMsg
      Case WM_INITDIALOG
        m2m hWnd, hWin
        invoke SendMessage,hWnd,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        invoke SetWindowText,hWnd,ADDR MainTitle

        mov hStatus, FUNC(GetDlgItem,hWnd,110)
        GLOBAL sbarray dd 100,200,300,400,-1
        invoke SendMessage,hStatus,SB_SETPARTS,5,ADDR sbarray

        mov hEdit,   FUNC(GetDlgItem,hWnd,111)
        invoke SendMessage,hEdit,WM_SETFONT,
                           FUNC(GetStockObject,ANSI_FIXED_FONT),TRUE
        mov eax, 1

      Case WM_COMMAND
        Switch wParam
          Case 101
          ; *************************************************************************

          ; The testing code for qsort3m

          ; *************************************************************************

            invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS
            invoke nseed, 87654321
            mov hMem, alloc(memsize*4)
            push hMem
            push esi
            push edi
            mov esi, memsize
            mov edi, hMem
          @@:
            invoke nrandom, randcnt
            mov [edi], eax
            add edi, 4
            sub esi, 1
            jnz @B
            pop edi
            pop esi
            invoke Sleep,250
            invoke GetTickCount
            push eax
          ; ==========================

            invoke qSortd,hMem,0,memsize

          ; ==========================

            invoke GetTickCount
            pop ecx
            sub eax, ecx
            fn MessageBox,hWnd,str$(eax),"Tri median qsort3m MASM",MB_OK

            pop hMem

            invoke is_correct,hMem,memsize-1
            test eax, eax
            jz @F
            sub eax, 1
            fn MessageBox,hWnd,str$(eax),"Failed at index",MB_OK
            ret
          @@:

            free hMem

            invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

          ; *************************************************************************

          Case 102
            TBtext "ID 102"
            SBtext 2,"Test 2"
            EDtext "Button 2 was pressed"

          Case 103
            TBtext "ID 103"
            SBtext 3,"Test 3"
            EDtext "This is button 3"

          Case 104
            TBtext "ID 104"
            SBtext 4,"Test 4"
            EDtext "The 4th button was pressed"

          Case 105
            TBtext "ID 105"
            SBtext 5,"Test 5"
            EDtext "OK, you pressed button 5"

          Case 106
            EDclear
            SBtext 1,0
            SBtext 2,0
            SBtext 3,0
            SBtext 4,0
            SBtext 5,0
            TBtext ADDR MainTitle

          Case IDCANCEL
            jmp quit_dialog
        Endsw

      Case WM_PAINT
        mov hDC, FUNC(BeginPaint,hWin,ADDR ps)
        invoke GetClientRect,hWin,ADDR rct
        invoke GetWindowRect,hStatus,ADDR crct
        mov eax, crct.bottom
        sub eax, crct.top
        sub rct.bottom, eax
        invoke DrawEdge,hDC,ADDR rct,EDGE_ETCHED,BF_RECT
        invoke EndPaint,hWin,ADDR ps

      Case WM_CLOSE
        quit_dialog: 
        invoke EndDialog,hWin,0
    Endsw

    xor eax, eax
    ret

DlgProc endp

; 

is_correct proc arrx:DWORD,acnt:DWORD

    push edi

    mov edx, acnt
    mov ecx, arrx
    xor edi, edi
    mov edi, -1

  @@:
    add edi, 1
    mov eax, [ecx+edi*4]
    cmp eax, [ecx+edi*4+4]

    jle nxt
  ; -------------------------------
  ; exit on error with index in EAX
  ; -------------------------------
    mov eax, edi
    add eax, 1
    jmp quit
  nxt:
    cmp edi, edx
    jne @B

    xor eax, eax

  quit:
    pop edi

    ret

is_correct endp

; 

align 16

qSortd proc arr:DWORD,lft:DWORD,rgt:DWORD

    push ebx
    push esi
    push edi

    mov ebx, arr

    mov eax, rgt
    add eax, lft
    cdq
    sub eax, edx
    sar eax, 1
    mov esi, eax

    mov edi, lft
    mov ecx, [ebx+edi*4]
    mov eax, [ebx+esi*4]
    cmp ecx, eax
    jle lbl0
    mov [ebx+esi*4], ecx
    mov [ebx+edi*4], eax

  lbl0:
    mov ecx, rgt
    mov edx, [ebx+edi*4]
    mov eax, [ebx+ecx*4]
    cmp edx, eax
    jle lbl1
    mov [ebx+ecx*4], edx
    mov [ebx+edi*4], eax

  lbl1:
    mov eax, [ebx+esi*4]
    mov edx, [ebx+ecx*4]
    cmp eax, edx
    jle lbl2
    mov [ebx+ecx*4], eax
    mov [ebx+esi*4], edx

  lbl2:
    mov eax, ecx
    sub eax, edi
    cmp eax, 1
    je lbl9

    mov edx, ecx                ; lea edi, [ecx-1]
    sub edx, 1
    mov edi, edx

    mov eax, [ebx+esi*4]
    mov edx, [ebx+edi*4]
    mov [ebx+edi*4], eax        ; set pivot
    mov [ebx+esi*4], edx

    mov esi, lft
    jmp lbl4

; ====================================

  align 4
  pre:
    mov [ebx+esi*4], edx
    mov [ebx+edi*4], ecx

  lbl4:
  REPEAT 7
    add esi, 1
    mov ecx, [ebx+esi*4]
    cmp ecx, eax
    jge lbl5
  ENDM
    add esi, 1
    mov ecx, [ebx+esi*4]
    cmp ecx, eax
    jl lbl4

  lbl5:
  REPEAT 7
    sub edi, 1
    mov edx, [ebx+edi*4]
    cmp edx, eax
    jle lbl6
  ENDM
    sub edi, 1
    mov edx, [ebx+edi*4]
    cmp edx, eax
    jg lbl5

  lbl6:
    cmp edi, esi
    jge pre

; ====================================

  lbl8:
    mov ecx, rgt
    mov edx, [ebx+esi*4]
    mov eax, [ebx+ecx*4-4]
    mov [ebx+ecx*4-4], edx
    mov [ebx+esi*4], eax

    mov eax, edi
    sub eax, lft
    test eax, eax
    jle @F
    invoke qSortd,ebx,lft,edi
  @@:

    add esi, 1

    mov eax, rgt
    sub eax, esi
    test eax, eax
    jle lbl9
    invoke qSortd,ebx,esi,rgt

  lbl9:
    pop edi
    pop esi
    pop ebx

    ret

qSortd endp

    nop
    nop
    nop

; 

end start
